;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;
;; Sub-Routine to gen SiteList
;;;;;;;;;;;;;;;;;;
SQLgenFilter:
GoSub SiteListUpdater_xml
GoSub SiteListUpdaterNoURL_xml
Return

;;; Generate SiteListUpdater.xml
SiteListUpdater_xml:
$vSiteList=
(
<?xml version="1.0" encoding="utf-8"?>
<m2filter version="1.0">
<package version="%Today%" author="pekkle @ HKSAR" description="by SiteListUpdater Plugins &lt;a href='http://forum.maxthon.com/viewthread.php?tid=63708' target=_blank&gt;English Forum&lt;/a&gt; &lt;a href='http://bbs.maxthon.cn/viewthread.php?tid=9300' target=_blank&gt;中文论坛&lt;/a&gt;" support_url="http://bbs.maxthon.cn/viewthread.php?tid=9300" title="SiteListUpdater"/>
<filterlist>
)

$sSQL =
( 
    select distinct '<filter enable="1" name="' || filtername || '/' || txt || '"',
           'match_url="' || domain || '"',
           'bound="' || regex || '"',
           'match="' || item || '"',
           'replace="$1 style\=display\:none\;"' ||
           ' type="text" action="3" priority="0" postaction=""' ||
           ' max_bound_size="128" author="" comment="" exclude_url=""' ||
           ' match_count="" exclude="style\=display\:none\;"' ||
           ' update="" ver="1.0" keywords=""/>' rule
    from tmp
    where type = 'E'
    and domain <> ''
    and item <> ''
    order by filtername, txt;
)
$iRC := _SQLite_GetTable($SQLITE_h_DB, $sSQL, $sResult, $iRows, $iCols, -1, 512)

Loop, Parse, $sResult, `n
{
If (A_Index > 1)
{
s_LoopField:=RegExReplace(A_LoopField, "\""\|", """ ")

$vSiteList=
(
%$vSiteList%
%s_LoopField%
)
}
}

$vSiteList=
(
%$vSiteList%
</filterlist>
</m2filter>
)

FileDelete SiteList.XML\SiteListUpdater.xml
FileAppend %$vSiteList%, SiteList.XML\SiteListUpdater.xml

Return

;;; Generate SiteListUpdaterNoURL.xml
SiteListUpdaterNoURL_xml:
$vSiteList=
(
<?xml version="1.0" encoding="utf-8"?>
<m2filter version="1.0">
<package version="%Today%" author="pekkle @ HKSAR" description="by SiteListUpdater Plugins &lt;a href='http://forum.maxthon.com/viewthread.php?tid=63708' target=_blank&gt;English Forum&lt;/a&gt; &lt;a href='http://bbs.maxthon.cn/viewthread.php?tid=9300' target=_blank&gt;中文论坛&lt;/a&gt;" support_url="http://bbs.maxthon.cn/viewthread.php?tid=9300" title="SiteListUpdaterNoURL"/>
<filterlist>
)

/*
    select distinct '<filter enable="' || case when txt like '`%#*(`%' then 0 else 1 end || '" name="' || filtername || '/' || txt || 
           '" match_url="' || domain || 
           '" bound="' || regex || 
           '" match="' || item || 
           '" replace="$1 style\=display\:none\;"' ||
           ' type="text" action="3" priority="0" postaction=""' ||
           ' max_bound_size="128" author="" comment="" exclude_url=""' ||
           ' match_count="" exclude="style\=display\:none\;"' ||
           ' update="" ver="1.0" keywords=""/>' rule
    from tmp
    where type = 'E'
    and domain = ''
    and item <> ''
    order by filtername, txt;
*/
$sSQL =
( 
    select distinct '<filter enable="1" name="' || filtername || '/' || txt || '"',
           'match_url="' || domain || '"',
           'bound="' || regex || '"',
           'match="' || item || '"',
           'replace="$1 style\=display\:none\;"' ||
           ' type="text" action="3" priority="0" postaction=""' ||
           ' max_bound_size="128" author="" comment="" exclude_url=""' ||
           ' match_count="" exclude="style\=display\:none\;"' ||
           ' update="" ver="1.0" keywords=""/>' rule
    from tmp
    where type = 'E'
    and domain = ''
    and item <> ''
    order by filtername, txt;
)
$iRC := _SQLite_GetTable($SQLITE_h_DB, $sSQL, $sResult, $iRows, $iCols, -1, 512)

Loop, Parse, $sResult, `n
{
If (A_Index > 1)
{
s_LoopField:=RegExReplace(A_LoopField, "\""\|", """ ")

$vSiteList=
(
%$vSiteList%
%s_LoopField%
)
}
}

$vSiteList=
(
%$vSiteList%
</filterlist>
</m2filter>
)

FileDelete SiteList.XML\SiteListUpdaterNoURL.xml
FileAppend %$vSiteList%, SiteList.XML\SiteListUpdaterNoURL.xml

Return
