ToRegEx(FilterTxt)
{
   ;;; Process the following char to convert into RegExp
   ;;; (1) x -> \x
   ;;;     \	.	,	:	;	/	[	]	^	$	+	(	)	&	~	?	-	=
   FilterTxt:=RegExReplace(FilterTxt, "is)([\\\.\,\:\;\/\[\]\^\$\+\(\)\&\~\?\-\=])", "\$1")

   ;;; (2) * -> .*
   FilterTxt:=RegExReplace(FilterTxt, "is)\*", ".*")

   ;;; (3) |... -> ^...
   ;;;     ...| -> ...$
   FilterTxt:=RegExReplace(FilterTxt, "is)^\|", "^")
   FilterTxt:=RegExReplace(FilterTxt, "is)\|$", "$")

   ;;; (4) other | -> \|
   FilterTxt:=RegExReplace(FilterTxt, "is)\|", "\|")

   Return %FilterTxt%
}
